/* @pjs preload="stone.png"; */

int numBoids 		= 15;

ArrayList boids 	= new ArrayList();
ArrayList foods 	= new ArrayList();

int[] pinkColors 	= new int();
int[] blueColors 	= new int();

var touches;

PVector target;

PImage b;
PImage tile;

Ripple ripple;

void setup() {
	size( window.innerWidth, window.innerHeight );

        frameRate( 24 );
        tile = loadImage("bg.jpg");
        b = new PImage (window.innerWidth, window.innerHeight);

        loadPixels ();
        ripple = new Ripple (b);
        for (i=0; i<b.width * b.height; i++)
            b.pixels[i] = pixels[i];

	// Create fishes
	for ( int n = 0; n < numBoids; n++ ) {
		PVector location = new PVector( random( 100, width - 100 ), random( 100, height - 100 ) );

		Fish fish = new Fish(location, random( 1.0, 8.5 ), 0.4 );
		boids.add( fish );
	}
}


void draw() {
//	background( 105, 210, 231, 255 );
//	background( 125, 230, 251, 0 );

/*
        for (int i=0; i< ceil (width / tile.width); i++)
            for (int j=0; j< ceil (height / tile.height); j++)
                image (tile, i * tile.width, j * tile.height);
*/

        image (tile, 0, 0, width, height);
//	background( 125, 230, 251, 50 );

	// Fish
	//for ( int i = boids.size() - 1; i >= 0; i-- ) {
	for ( int i = 0; i < boids.size(); i++ ) {
		Fish fish = (Fish)boids.get( i );
		fish.update();
		fish.render();

		// If there is any food in the pond
		if ( foods.size() > 0 ) {
			// Check if a fish is near one and apply arrive void behaviour
			//for ( int j = foods.size() - 1; j >= 0; j-- ) {
			for ( int j = 0; j < foods.size(); j++ ) {
				Food food 		= (Food)foods.get( j );
				PVector fLoc 	= food.location.get();
				PVector bLoc 	= fish.location.get();
				float d 		= bLoc.dist( fLoc );
				if ( d < 80.0 ) {
					fish.arrive( fLoc );
					if ( fish.hasArrive === true ) {
						food.isDead = true;
						fish.hasArrive = false;
					}
				}
			}
		}
	}

	// Food
	for ( int f = foods.size() - 1; f >= 0; f-- ) {
		Food food = (Food)foods.get( f );
		food.update();
		food.render();
		if ( food.isDead ) {
			foods.remove( f );
		}
	}


/*
        loadPixels ();

        for (i=0; i<b.width * b.height; i++)
            b.pixels[i] = pixels[i];
*/

        ripple.update ();
}


void mouseDragged() {
	// Add food
	if ( millis() % 10 == 0 ) {
//		foods.add( new Food( new PVector( mouseX, mouseY ) ) );
	}
}

void setTarget (int x, int y) {
    target = new PVector (x, y);

//    ripple.makeTurbulence (x, y);

     for ( int i = 0; i < boids.size(); i++ ) {
         Fish fish = (Fish)boids.get( i );

         if (target && (random (3) < 2))
             fish.setSeekTarget (target);

     }

    for (var i=0; i<MAX_AUDIO; i++)
        if (audio[i].paused || audio[i].ended) {
            audio[i].src = "./water_samples/splash_"+(Math.floor (Math.random () * 3 + 1))+".ogg";
            audio[i].play ();
            audio[i].currentTime = 200.0;
        }
}

void mousePressed() {
    setTarget (mouseX, mouseY);
}

void mouseMoved(){
}

function touchMove( evt ) {
	// Add food
	evt.touches;
	if ( millis() % 10 == 0 ) {
		foods.add( new Food( new PVector( touches[0].pageX, touches[0].pageY ) ) );
	}
}

function touchEnd( evt ) {
	touches = undefined;
}

var MAX_AUDIO = 3;
var audio = [];

$ (function () {
    var ws = new WebSocket ("ws://localhost:8081/");
    ws.onopen = function () {
    };

    ws.onmessage = function (msg) {
        var coords = JSON.parse (msg.data);

        console.log (msg.data);

        var x = Math.floor ((coords[0] * window.innerWidth) / 100);
        var y = Math.floor ((coords[1] * window.innerHeight) / 100);

        console.log (x + ", " + y);

        setTarget (x, y);
    };

    for (var i=0; i<MAX_AUDIO; i++) {
        audio[i] = document.createElement ("audio");
        document.body.appendChild (audio[i]);
    }
});
